static const char *RcsId     = "$Header: /home/cvsadm/cvsroot/fermi/servers/guntiming/src/GuntimingClass.cpp,v 1.1.1.1 2014-12-11 14:05:08 zambonl Exp $";
static const char *TagName   = "$Name:  $";
static const char *HttpServer= "http://www.esrf.fr/computing/cs/tango/tango_doc/ds_doc/";
//+=============================================================================
//
// file :        GuntimingClass.cpp
//
// description : C++ source for the GuntimingClass. A singleton
//               class derived from DeviceClass. It implements the
//               command list and all properties and methods required
//               by the Guntiming once per process.
//
// project :     TANGO Device Server
//
// $Author: zambonl $
//
// $Revision: 1.1.1.1 $
//
// $Log: GuntimingClass.cpp,v $
// Revision 1.1.1.1  2014-12-11 14:05:08  zambonl
// Prima versione
//
// Revision 1.1.1.1  2014-11-11 10:00:36  zambonl
// Prima versione
//
// Revision 1.1.1.1  2013-08-06 08:24:53  zambonl
// Prima versione
//
//
// copyleft :   European Synchrotron Radiation Facility
//              BP 220, Grenoble 38043
//              FRANCE
//
//-=============================================================================
//
//  		This file is generated by POGO
//	(Program Obviously used to Generate tango Object)
//
//         (c) - Software Engineering Group - ESRF
//=============================================================================


#include <tango.h>

#include <Guntiming.h>
#include <GuntimingClass.h>


//+----------------------------------------------------------------------------
/**
 *	Create GuntimingClass singleton and return it in a C function for Python usage
 */
//+----------------------------------------------------------------------------
extern "C" {
#ifdef WIN32

__declspec(dllexport)

#endif

	Tango::DeviceClass *_create_Guntiming_class(const char *name) {
		return Guntiming_ns::GuntimingClass::init(name);
	}
}


namespace Guntiming_ns
{
//+----------------------------------------------------------------------------
//
// method : 		RestartClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *RestartClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "RestartClass::execute(): arrived" << endl;

	((static_cast<Guntiming *>(device))->restart());
	return new CORBA::Any();
}




//+----------------------------------------------------------------------------
//
// method : 		RawClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *RawClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout << "RawClass::execute(): arrived" << endl;

	Tango::DevString	argin;
	extract(in_any, argin);

	/*((static_cast<Guntiming *>(device))->raw(argin));
	cout << "RawClass::execute(): done" << endl;
	return new CORBA::Any();*/
	return insert((static_cast<Guntiming *>(device))->raw(argin));
}

//+----------------------------------------------------------------------------
//
// method : 		StinitClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *StinitClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "StinitClass::execute(): arrived" << endl;

	((static_cast<Guntiming *>(device))->stinit());
	return new CORBA::Any();
}

//
//----------------------------------------------------------------
//	Initialize pointer for singleton pattern
//----------------------------------------------------------------
//
GuntimingClass *GuntimingClass::_instance = NULL;

//+----------------------------------------------------------------------------
//
// method : 		GuntimingClass::GuntimingClass(string &s)
// 
// description : 	constructor for the GuntimingClass
//
// in : - s : The class name
//
//-----------------------------------------------------------------------------
GuntimingClass::GuntimingClass(string &s):DeviceClass(s)
{

	cout2 << "Entering GuntimingClass constructor" << endl;
	set_default_property();
	write_class_property();
	get_class_property();
	
	cout2 << "Leaving GuntimingClass constructor" << endl;

}
//+----------------------------------------------------------------------------
//
// method : 		GuntimingClass::~GuntimingClass()
// 
// description : 	destructor for the GuntimingClass
//
//-----------------------------------------------------------------------------
GuntimingClass::~GuntimingClass()
{
	_instance = NULL;
}

//+----------------------------------------------------------------------------
//
// method : 		GuntimingClass::instance
// 
// description : 	Create the object if not already done. Otherwise, just
//			return a pointer to the object
//
// in : - name : The class name
//
//-----------------------------------------------------------------------------
GuntimingClass *GuntimingClass::init(const char *name)
{
	if (_instance == NULL)
	{
		try
		{
			string s(name);
			_instance = new GuntimingClass(s);
		}
		catch (bad_alloc)
		{
			throw;
		}		
	}		
	return _instance;
}

GuntimingClass *GuntimingClass::instance()
{
	if (_instance == NULL)
	{
		cerr << "Class is not initialised !!" << endl;
		exit(-1);
	}
	return _instance;
}

//+----------------------------------------------------------------------------
//
// method : 		GuntimingClass::command_factory
// 
// description : 	Create the command object(s) and store them in the 
//			command list
//
//-----------------------------------------------------------------------------
void GuntimingClass::command_factory()
{
	command_list.push_back(new RawClass("Raw",
		Tango::DEV_STRING, Tango::DEVVAR_STRINGARRAY,
		"raw command to lantronix",
		"response",
		Tango::OPERATOR));
	command_list.push_back(new StinitClass("Stinit",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new RestartClass("Restart",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));

	//	add polling if any
	for (unsigned int i=0 ; i<command_list.size(); i++)
	{
	}
}

//+----------------------------------------------------------------------------
//
// method : 		GuntimingClass::get_class_property
// 
// description : 	Get the class property for specified name.
//
// in :		string	name : The property name
//
//+----------------------------------------------------------------------------
Tango::DbDatum GuntimingClass::get_class_property(string &prop_name)
{
	for (int i=0 ; i<cl_prop.size() ; i++)
		if (cl_prop[i].name == prop_name)
			return cl_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}
//+----------------------------------------------------------------------------
//
// method : 		GuntimingClass::get_default_device_property()
// 
// description : 	Return the default value for device property.
//
//-----------------------------------------------------------------------------
Tango::DbDatum GuntimingClass::get_default_device_property(string &prop_name)
{
	for (int i=0 ; i<dev_def_prop.size() ; i++)
		if (dev_def_prop[i].name == prop_name)
			return dev_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//+----------------------------------------------------------------------------
//
// method : 		GuntimingClass::get_default_class_property()
// 
// description : 	Return the default value for class property.
//
//-----------------------------------------------------------------------------
Tango::DbDatum GuntimingClass::get_default_class_property(string &prop_name)
{
	for (int i=0 ; i<cl_def_prop.size() ; i++)
		if (cl_def_prop[i].name == prop_name)
			return cl_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}
//+----------------------------------------------------------------------------
//
// method : 		GuntimingClass::device_factory
// 
// description : 	Create the device object(s) and store them in the 
//			device list
//
// in :		Tango::DevVarStringArray *devlist_ptr : The device name list
//
//-----------------------------------------------------------------------------
void GuntimingClass::device_factory(const Tango::DevVarStringArray *devlist_ptr)
{

	//	Create all devices.(Automatic code generation)
	//-------------------------------------------------------------
	for (unsigned long i=0 ; i < devlist_ptr->length() ; i++)
	{
		cout4 << "Device name : " << (*devlist_ptr)[i].in() << endl;
						
		// Create devices and add it into the device list
		//----------------------------------------------------
		device_list.push_back(new Guntiming(this, (*devlist_ptr)[i]));							 

		// Export device to the outside world
		// Check before if database used.
		//---------------------------------------------
		if ((Tango::Util::_UseDb == true) && (Tango::Util::_FileDb == false))
			export_device(device_list.back());
		else
			export_device(device_list.back(), (*devlist_ptr)[i]);
	}
	//	End of Automatic code generation
	//-------------------------------------------------------------

}
//+----------------------------------------------------------------------------
//	Method: GuntimingClass::attribute_factory(vector<Tango::Attr *> &att_list)
//-----------------------------------------------------------------------------
void GuntimingClass::attribute_factory(vector<Tango::Attr *> &att_list)
{
	//	Attribute : FilCur
	FilCurAttrib	*fil_cur = new FilCurAttrib();
	att_list.push_back(fil_cur);

	//	Attribute : FilCurset
	FilCursetAttrib	*fil_curset = new FilCursetAttrib();
	att_list.push_back(fil_curset);

	//	Attribute : FilVoltage
	FilVoltageAttrib	*fil_voltage = new FilVoltageAttrib();
	att_list.push_back(fil_voltage);

	//	Attribute : GridVoltage
	GridVoltageAttrib	*grid_voltage = new GridVoltageAttrib();
	att_list.push_back(grid_voltage);

	//	Attribute : Mode
	ModeAttrib	*mode = new ModeAttrib();
	att_list.push_back(mode);

	//	Attribute : Modestring
	ModestringAttrib	*modestring = new ModestringAttrib();
	att_list.push_back(modestring);

	//	Attribute : PolVoltage
	PolVoltageAttrib	*pol_voltage = new PolVoltageAttrib();
	att_list.push_back(pol_voltage);

	//	Attribute : Temperature
	TemperatureAttrib	*temperature = new TemperatureAttrib();
	att_list.push_back(temperature);

	//	Attribute : DriverCur
	DriverCurAttrib	*driver_cur = new DriverCurAttrib();
	att_list.push_back(driver_cur);

	//	Attribute : DriverVoltage
	DriverVoltageAttrib	*driver_voltage = new DriverVoltageAttrib();
	att_list.push_back(driver_voltage);

	//	Attribute : BunchLength
	BunchLengthAttrib	*bunch_length = new BunchLengthAttrib();
	att_list.push_back(bunch_length);

	//	Attribute : StateFlags
	StateFlagsAttrib	*state_flags = new StateFlagsAttrib();
	Tango::UserDefaultAttrProp	state_flags_prop;
	state_flags_prop.set_description("0: PSS\n1: wait for filament heating\n2: grid offset too high\n3: filament offset too high");
	state_flags->set_default_properties(state_flags_prop);
	att_list.push_back(state_flags);

}

//+----------------------------------------------------------------------------
//
// method : 		GuntimingClass::get_class_property()
// 
// description : 	Read the class properties from database.
//
//-----------------------------------------------------------------------------
void GuntimingClass::get_class_property()
{
	//	Initialize your default values here (if not done with  POGO).
	//------------------------------------------------------------------

	//	Read class properties from database.(Automatic code generation)
	//------------------------------------------------------------------

	//	Call database and extract values
	//--------------------------------------------
	if (Tango::Util::instance()->_UseDb==true)
		get_db_class()->get_property(cl_prop);
	Tango::DbDatum	def_prop;
	int	i = -1;


	//	End of Automatic code generation
	//------------------------------------------------------------------

}

//+----------------------------------------------------------------------------
//
// method : 	GuntimingClass::set_default_property
// 
// description: Set default property (class and device) for wizard.
//              For each property, add to wizard property name and description
//              If default value has been set, add it to wizard property and
//              store it in a DbDatum.
//
//-----------------------------------------------------------------------------
void GuntimingClass::set_default_property()
{
	string	prop_name;
	string	prop_desc;
	string	prop_def;

	vector<string>	vect_data;
	//	Set Default Class Properties
	//	Set Default Device Properties
	prop_name = "IP";
	prop_desc = "";
	prop_def  = "192.168.205.126";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);


}
//+----------------------------------------------------------------------------
//
// method : 		GuntimingClass::write_class_property
// 
// description : 	Set class description as property in database
//
//-----------------------------------------------------------------------------
void GuntimingClass::write_class_property()
{
	//	First time, check if database used
	//--------------------------------------------
	if (Tango::Util::_UseDb == false)
		return;

	Tango::DbData	data;
	string	classname = get_name();
	string	header;
	string::size_type	start, end;

	//	Put title
	Tango::DbDatum	title("ProjectTitle");
	string	str_title("gun timing");
	title << str_title;
	data.push_back(title);

	//	Put Description
	Tango::DbDatum	description("Description");
	vector<string>	str_desc;
	str_desc.push_back("Timing system for the preinjector gun");
	description << str_desc;
	data.push_back(description);
		
	//	put cvs location
	string	rcsId(RcsId);
	string	filename(classname);
	start = rcsId.find("/");
	if (start!=string::npos)
	{
		filename += "Class.cpp";
		end   = rcsId.find(filename);
		if (end>start)
		{
			string	strloc = rcsId.substr(start, end-start);
			//	Check if specific repository
			start = strloc.find("/cvsroot/");
			if (start!=string::npos && start>0)
			{
				string	repository = strloc.substr(0, start);
				if (repository.find("/segfs/")!=string::npos)
					strloc = "ESRF:" + strloc.substr(start, strloc.length()-start);
			}
			Tango::DbDatum	cvs_loc("cvs_location");
			cvs_loc << strloc;
			data.push_back(cvs_loc);
		}
	}

	//	Get CVS tag revision
	string	tagname(TagName);
	header = "$Name: ";
	start = header.length();
	string	endstr(" $");
	end   = tagname.find(endstr);
	if (end!=string::npos && end>start)
	{
		string	strtag = tagname.substr(start, end-start);
		Tango::DbDatum	cvs_tag("cvs_tag");
		cvs_tag << strtag;
		data.push_back(cvs_tag);
	}

	//	Get URL location
	string	httpServ(HttpServer);
	if (httpServ.length()>0)
	{
		Tango::DbDatum	db_doc_url("doc_url");
		db_doc_url << httpServ;
		data.push_back(db_doc_url);
	}

	//  Put inheritance
	Tango::DbDatum	inher_datum("InheritedFrom");
	vector<string> inheritance;
	inheritance.push_back("Device_4Impl");
	inher_datum << inheritance;
	data.push_back(inher_datum);

	//	Call database and and values
	//--------------------------------------------
	get_db_class()->put_property(data);
}

}	// namespace
